// Objective-C API for talking to github.com/jerson/openpgp-mobile/openpgp Go package.
//   gobind -lang=objc github.com/jerson/openpgp-mobile/openpgp
//
// File is generated by gobind. Do not edit.

#ifndef __OpenpgpMobile_H__
#define __OpenpgpMobile_H__

@import Foundation;
#include "ref.h"
#include "Universe.objc.h"


@class OpenpgpMobileFastOpenPGP;
@class OpenpgpMobileKeyOptions;
@class OpenpgpMobileKeyPair;
@class OpenpgpMobileOptions;

@interface OpenpgpMobileFastOpenPGP : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
- (nullable instancetype)init;
- (NSString* _Nonnull)decrypt:(NSString* _Nullable)message privateKey:(NSString* _Nullable)privateKey passphrase:(NSString* _Nullable)passphrase error:(NSError* _Nullable* _Nullable)error;
- (NSString* _Nonnull)decryptSymmetric:(NSString* _Nullable)message passphrase:(NSString* _Nullable)passphrase options:(OpenpgpMobileKeyOptions* _Nullable)options error:(NSError* _Nullable* _Nullable)error;
- (NSString* _Nonnull)encrypt:(NSString* _Nullable)message publicKey:(NSString* _Nullable)publicKey error:(NSError* _Nullable* _Nullable)error;
- (NSString* _Nonnull)encryptSymmetric:(NSString* _Nullable)message passphrase:(NSString* _Nullable)passphrase options:(OpenpgpMobileKeyOptions* _Nullable)options error:(NSError* _Nullable* _Nullable)error;
- (OpenpgpMobileKeyPair* _Nullable)generate:(OpenpgpMobileOptions* _Nullable)options error:(NSError* _Nullable* _Nullable)error;
- (NSString* _Nonnull)sign:(NSString* _Nullable)message publicKey:(NSString* _Nullable)publicKey privateKey:(NSString* _Nullable)privateKey passphrase:(NSString* _Nullable)passphrase error:(NSError* _Nullable* _Nullable)error;
- (BOOL)verify:(NSString* _Nullable)signature message:(NSString* _Nullable)message publicKey:(NSString* _Nullable)publicKey ret0_:(BOOL* _Nullable)ret0_ error:(NSError* _Nullable* _Nullable)error;
@end

@interface OpenpgpMobileKeyOptions : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
- (nonnull instancetype)init;
@property (nonatomic) NSString* _Nonnull hash;
@property (nonatomic) NSString* _Nonnull cipher;
@property (nonatomic) NSString* _Nonnull compression;
@property (nonatomic) long compressionLevel;
@property (nonatomic) long rsaBits;
- (void)setCompressionLevelFromString:(NSString* _Nullable)value;
- (void)setRSABitsFromString:(NSString* _Nullable)value;
@end

@interface OpenpgpMobileKeyPair : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
- (nonnull instancetype)init;
@property (nonatomic) NSString* _Nonnull publicKey;
@property (nonatomic) NSString* _Nonnull privateKey;
@end

@interface OpenpgpMobileOptions : NSObject <goSeqRefInterface> {
}
@property(strong, readonly) _Nonnull id _ref;

- (nonnull instancetype)initWithRef:(_Nonnull id)ref;
- (nonnull instancetype)init;
@property (nonatomic) OpenpgpMobileKeyOptions* _Nullable keyOptions;
@property (nonatomic) NSString* _Nonnull name;
@property (nonatomic) NSString* _Nonnull comment;
@property (nonatomic) NSString* _Nonnull email;
@property (nonatomic) NSString* _Nonnull passphrase;
@end

FOUNDATION_EXPORT OpenpgpMobileFastOpenPGP* _Nullable OpenpgpMobileNewFastOpenPGP(void);

#endif
